/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VVariableRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VVariable extends TableImpl<VVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_variable</code>
     */
    public static final VVariable V_VARIABLE = new VVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VVariableRecord> getRecordType() {
        return VVariableRecord.class;
    }

    /**
     * The column <code>common_dd.v_variable.key_element</code>.
     */
    public final TableField<VVariableRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.key_element_type</code>.
     */
    public final TableField<VVariableRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.key_parent_element</code>.
     */
    public final TableField<VVariableRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.dn</code>.
     */
    public final TableField<VVariableRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_variable.order_nr</code>.
     */
    public final TableField<VVariableRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.short_name</code>.
     */
    public final TableField<VVariableRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_variable.is_public</code>.
     */
    public final TableField<VVariableRecord, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.hier_lang</code>.
     */
    public final TableField<VVariableRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_variable.valuelist</code>.
     */
    public final TableField<VVariableRecord, Integer> VALUELIST = createField(DSL.name("valuelist"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.var_order</code>.
     */
    public final TableField<VVariableRecord, Integer> VAR_ORDER = createField(DSL.name("var_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.var_ecrf</code>.
     */
    public final TableField<VVariableRecord, Integer> VAR_ECRF = createField(DSL.name("var_ecrf"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.var_formposx</code>.
     */
    public final TableField<VVariableRecord, Integer> VAR_FORMPOSX = createField(DSL.name("var_formposx"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.var_formposy</code>.
     */
    public final TableField<VVariableRecord, Integer> VAR_FORMPOSY = createField(DSL.name("var_formposy"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.fk_var_inputtype</code>.
     */
    public final TableField<VVariableRecord, Integer> FK_VAR_INPUTTYPE = createField(DSL.name("fk_var_inputtype"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.default_value</code>.
     */
    public final TableField<VVariableRecord, Integer> DEFAULT_VALUE = createField(DSL.name("default_value"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_variable.fk_var_inputhelp</code>.
     */
    public final TableField<VVariableRecord, Integer> FK_VAR_INPUTHELP = createField(DSL.name("fk_var_inputhelp"), SQLDataType.INTEGER, this, "");

    private VVariable(Name alias, Table<VVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VVariable(Name alias, Table<VVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
         create view "v_variable" as  SELECT h.key_element,
            h.key_element_type,
            h.key_parent_element,
            h.dn,
            h.order_nr,
            h.short_name,
            h.is_public,
            h.hier_lang,
            v.fk_var_valuelist AS valuelist,
            NULL::integer AS var_order,
            NULL::integer AS var_ecrf,
            NULL::integer AS var_formposx,
            NULL::integer AS var_formposy,
            NULL::integer AS fk_var_inputtype,
            NULL::integer AS default_value,
            NULL::integer AS fk_var_inputhelp
           FROM common_dd.t_core_element_hierarchy h,
            common_dd.t_core_variable v
          WHERE ((h.key_element = v.key_variable) AND (NOT (h.key_element IN ( SELECT t_input_variable.fk_variable
                   FROM common_dd.t_input_variable))))
        UNION ALL
         SELECT h.key_element,
            h.key_element_type,
            h.key_parent_element,
            h.dn,
            h.order_nr,
            h.short_name,
            h.is_public,
            h.hier_lang,
            v.fk_var_valuelist AS valuelist,
            i.var_order,
            i.var_ecrf,
            i.var_formposx,
            i.var_formposy,
            i.fk_var_inputtype,
            i.default_value,
            i.fk_var_inputhelp
           FROM common_dd.t_core_element_hierarchy h,
            common_dd.t_core_variable v,
            common_dd.t_input_variable i
          WHERE ((h.key_element = v.key_variable) AND (h.key_element = i.fk_variable));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_variable</code> table reference
     */
    public VVariable(String alias) {
        this(DSL.name(alias), V_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.v_variable</code> table reference
     */
    public VVariable(Name alias) {
        this(alias, V_VARIABLE);
    }

    /**
     * Create a <code>common_dd.v_variable</code> table reference
     */
    public VVariable() {
        this(DSL.name("v_variable"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VVariable as(String alias) {
        return new VVariable(DSL.name(alias), this);
    }

    @Override
    public VVariable as(Name alias) {
        return new VVariable(alias, this);
    }

    @Override
    public VVariable as(Table<?> alias) {
        return new VVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VVariable rename(String name) {
        return new VVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VVariable rename(Name name) {
        return new VVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VVariable rename(Table<?> name) {
        return new VVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVariable where(Condition condition) {
        return new VVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
